# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class AngazovanaOsobaFiltr(BaseModel):
    """
    Angažovaná osoba
    """ # noqa: E501
    jmeno: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="Jméno angažované osoby")
    rodne_cislo: Optional[Annotated[str, Field(min_length=9, strict=True, max_length=10)]] = Field(default=None, description="Rodné číslo osoby", alias="rodneCislo")
    prijmeni: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="Příjmení angažované osoby")
    datum_narozeni: Optional[date] = Field(default=None, description="Datum narození angažované osoby", alias="datumNarozeni")
    __properties: ClassVar[List[str]] = ["jmeno", "rodneCislo", "prijmeni", "datumNarozeni"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AngazovanaOsobaFiltr from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AngazovanaOsobaFiltr from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "jmeno": obj.get("jmeno"),
            "rodneCislo": obj.get("rodneCislo"),
            "prijmeni": obj.get("prijmeni"),
            "datumNarozeni": obj.get("datumNarozeni")
        })
        return _obj


