# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.adresa_rcns import AdresaRcns
from openapi_client.models.angazovana_osoba_rcns import AngazovanaOsobaRcns
from typing import Optional, Set
from typing_extensions import Self

class AngazovanySubjektRcns(BaseModel):
    """
    AngazovanySubjektRcns
    """ # noqa: E501
    ico: Optional[Annotated[str, Field(min_length=8, strict=True, max_length=8)]] = None
    dic: Optional[StrictStr] = Field(default=None, description="DIČ")
    platnost_od: Optional[date] = Field(default=None, description="Platnost záznamu od data", alias="platnostOd")
    platnost_do: Optional[date] = Field(default=None, description="Platnost záznamu do data", alias="platnostDo")
    sidlo: Optional[AdresaRcns] = None
    obchodni_jmeno: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=2000)]] = Field(default=None, description="Obchodní jméno subjektu", alias="obchodniJmeno")
    kod_statu: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(default=None, description="Kód státu  (ciselnikKod: Stat) ", alias="kodStatu")
    pravni_forma: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(default=None, description="Právní forma - kód (ciselnikKod: PravniForma) ", alias="pravniForma")
    statutarni_organy: Optional[List[AngazovanaOsobaRcns]] = Field(default=None, alias="statutarniOrgany")
    __properties: ClassVar[List[str]] = ["ico", "dic", "platnostOd", "platnostDo", "sidlo", "obchodniJmeno", "kodStatu", "pravniForma", "statutarniOrgany"]

    @field_validator('ico')
    def ico_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{8}$", value):
            raise ValueError(r"must validate the regular expression /^\d{8}$/")
        return value

    @field_validator('pravni_forma')
    def pravni_forma_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{3}$", value):
            raise ValueError(r"must validate the regular expression /^\d{3}$/")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AngazovanySubjektRcns from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of sidlo
        if self.sidlo:
            _dict['sidlo'] = self.sidlo.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in statutarni_organy (list)
        _items = []
        if self.statutarni_organy:
            for _item in self.statutarni_organy:
                if _item:
                    _items.append(_item.to_dict())
            _dict['statutarniOrgany'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AngazovanySubjektRcns from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ico": obj.get("ico"),
            "dic": obj.get("dic"),
            "platnostOd": obj.get("platnostOd"),
            "platnostDo": obj.get("platnostDo"),
            "sidlo": AdresaRcns.from_dict(obj["sidlo"]) if obj.get("sidlo") is not None else None,
            "obchodniJmeno": obj.get("obchodniJmeno"),
            "kodStatu": obj.get("kodStatu"),
            "pravniForma": obj.get("pravniForma"),
            "statutarniOrgany": [AngazovanaOsobaRcns.from_dict(_item) for _item in obj["statutarniOrgany"]] if obj.get("statutarniOrgany") is not None else None
        })
        return _obj


