# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.polozka_ciselniku import PolozkaCiselniku
from typing import Optional, Set
from typing_extensions import Self

class Ciselnik(BaseModel):
    """
    Číselník
    """ # noqa: E501
    kod_ciselniku: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=64)]] = Field(default=None, description="Kód číselníku", alias="kodCiselniku")
    nazev_ciselniku: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="Název číselníku", alias="nazevCiselniku")
    polozky_ciselniku: Optional[List[PolozkaCiselniku]] = Field(default=None, alias="polozkyCiselniku")
    zdroj_ciselniku: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=64)]] = Field(default=None, description="Zdroj číselníku (ciselnikKod: StavZdroje) ", alias="zdrojCiselniku")
    __properties: ClassVar[List[str]] = ["kodCiselniku", "nazevCiselniku", "polozkyCiselniku", "zdrojCiselniku"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Ciselnik from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in polozky_ciselniku (list)
        _items = []
        if self.polozky_ciselniku:
            for _item in self.polozky_ciselniku:
                if _item:
                    _items.append(_item.to_dict())
            _dict['polozkyCiselniku'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Ciselnik from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "kodCiselniku": obj.get("kodCiselniku"),
            "nazevCiselniku": obj.get("nazevCiselniku"),
            "polozkyCiselniku": [PolozkaCiselniku.from_dict(_item) for _item in obj["polozkyCiselniku"]] if obj.get("polozkyCiselniku") is not None else None,
            "zdrojCiselniku": obj.get("zdrojCiselniku")
        })
        return _obj


