# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.adresa_ares import AdresaAres
from openapi_client.models.obchodni_jmeno_ares import ObchodniJmenoAres
from typing import Optional, Set
from typing_extensions import Self

class EkonomickySubjektDalsiUdaje(BaseModel):
    """
    Další údaje o ekonomickém subjektu
    """ # noqa: E501
    obchodni_jmeno: Optional[List[ObchodniJmenoAres]] = Field(default=None, alias="obchodniJmeno")
    sidlo: Optional[List[AdresaAres]] = None
    pravni_forma: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(default=None, description="Právní forma - kód (ciselnikKod: PravniForma, zdroj: res, com)", alias="pravniForma")
    spisova_znacka: Optional[Annotated[str, Field(strict=True, max_length=32)]] = Field(default=None, description="Aktuální spisová značka ve tvaru ODDIL xx/SOUD (např. B 100/MSPH) - poskytováno pouze pro zdroj: Veřejné rejstříky ", alias="spisovaZnacka")
    datovy_zdroj: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(default=None, description="Identifikace primárního zdroje dat - kód (ciselnikKod: TypZdroje, zdroj: com) ", alias="datovyZdroj")
    __properties: ClassVar[List[str]] = ["obchodniJmeno", "sidlo", "pravniForma", "spisovaZnacka", "datovyZdroj"]

    @field_validator('pravni_forma')
    def pravni_forma_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{3}$", value):
            raise ValueError(r"must validate the regular expression /^\d{3}$/")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EkonomickySubjektDalsiUdaje from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in obchodni_jmeno (list)
        _items = []
        if self.obchodni_jmeno:
            for _item in self.obchodni_jmeno:
                if _item:
                    _items.append(_item.to_dict())
            _dict['obchodniJmeno'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in sidlo (list)
        _items = []
        if self.sidlo:
            for _item in self.sidlo:
                if _item:
                    _items.append(_item.to_dict())
            _dict['sidlo'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EkonomickySubjektDalsiUdaje from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "obchodniJmeno": [ObchodniJmenoAres.from_dict(_item) for _item in obj["obchodniJmeno"]] if obj.get("obchodniJmeno") is not None else None,
            "sidlo": [AdresaAres.from_dict(_item) for _item in obj["sidlo"]] if obj.get("sidlo") is not None else None,
            "pravniForma": obj.get("pravniForma"),
            "spisovaZnacka": obj.get("spisovaZnacka"),
            "datovyZdroj": obj.get("datovyZdroj")
        })
        return _obj


