# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.angazma_osoba_vr import AngazmaOsobaVr
from openapi_client.models.obecny_text_vr import ObecnyTextVr
from typing import Optional, Set
from typing_extensions import Self

class KonkursVr(BaseModel):
    """
    Konkurzní řízení
    """ # noqa: E501
    datum_zapisu: Optional[date] = Field(default=None, description="Datum zápisu údaje", alias="datumZapisu")
    datum_vymazu: Optional[date] = Field(default=None, description="Datum výmazu údaje", alias="datumVymazu")
    spravce: Optional[List[AngazmaOsobaVr]] = None
    typ_konkursu: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="Typ konkursu - kód (ciselnikKod: TypKonkursu) ", alias="typKonkursu")
    datum_rozhodnuti_os: Optional[date] = Field(default=None, description="Datum rozhodnutí okresního soudu", alias="datumRozhodnutiOs")
    datum_vyveseni: Optional[date] = Field(default=None, description="Datum vyvěšení rozhodnutí", alias="datumVyveseni")
    spis_zn_os: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, alias="spisZnOs")
    text: Optional[StrictStr] = Field(default=None, description="Vlastní informace o konkurzním řízení")
    zruseni_konkursu: Optional[List[ObecnyTextVr]] = Field(default=None, alias="zruseniKonkursu")
    __properties: ClassVar[List[str]] = ["datumZapisu", "datumVymazu", "spravce", "typKonkursu", "datumRozhodnutiOs", "datumVyveseni", "spisZnOs", "text", "zruseniKonkursu"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of KonkursVr from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in spravce (list)
        _items = []
        if self.spravce:
            for _item in self.spravce:
                if _item:
                    _items.append(_item.to_dict())
            _dict['spravce'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in zruseni_konkursu (list)
        _items = []
        if self.zruseni_konkursu:
            for _item in self.zruseni_konkursu:
                if _item:
                    _items.append(_item.to_dict())
            _dict['zruseniKonkursu'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of KonkursVr from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "datumZapisu": obj.get("datumZapisu"),
            "datumVymazu": obj.get("datumVymazu"),
            "spravce": [AngazmaOsobaVr.from_dict(_item) for _item in obj["spravce"]] if obj.get("spravce") is not None else None,
            "typKonkursu": obj.get("typKonkursu"),
            "datumRozhodnutiOs": obj.get("datumRozhodnutiOs"),
            "datumVyveseni": obj.get("datumVyveseni"),
            "spisZnOs": obj.get("spisZnOs"),
            "text": obj.get("text"),
            "zruseniKonkursu": [ObecnyTextVr.from_dict(_item) for _item in obj["zruseniKonkursu"]] if obj.get("zruseniKonkursu") is not None else None
        })
        return _obj


