# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.notifikace import Notifikace
from typing import Optional, Set
from typing_extensions import Self

class NotifikacniDavkaZaznam(BaseModel):
    """
    Notifikační dávka datového zdroje
    """ # noqa: E501
    cislo_davky: Optional[StrictInt] = Field(default=None, description="Číslo notifikační dávky", alias="cisloDavky")
    datovy_zdroj: Optional[Annotated[str, Field(strict=True, max_length=30)]] = Field(default=None, description="Datový zdroj notifikační dávky - kód (ciselnikKod: TypZdrojeAres, zdroj:com) ", alias="datovyZdroj")
    datum_uvolneni_davky: Optional[date] = Field(default=None, description="Datum uvolnění notifikační dávky", alias="datumUvolneniDavky")
    pocet_zmen: Optional[StrictInt] = Field(default=None, description="Počet změn v notifikační dávce", alias="pocetZmen")
    seznam_notifikaci: Optional[List[Notifikace]] = Field(default=None, alias="seznamNotifikaci")
    __properties: ClassVar[List[str]] = ["cisloDavky", "datovyZdroj", "datumUvolneniDavky", "pocetZmen", "seznamNotifikaci"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NotifikacniDavkaZaznam from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in seznam_notifikaci (list)
        _items = []
        if self.seznam_notifikaci:
            for _item in self.seznam_notifikaci:
                if _item:
                    _items.append(_item.to_dict())
            _dict['seznamNotifikaci'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NotifikacniDavkaZaznam from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cisloDavky": obj.get("cisloDavky"),
            "datovyZdroj": obj.get("datovyZdroj"),
            "datumUvolneniDavky": obj.get("datumUvolneniDavky"),
            "pocetZmen": obj.get("pocetZmen"),
            "seznamNotifikaci": [Notifikace.from_dict(_item) for _item in obj["seznamNotifikaci"]] if obj.get("seznamNotifikaci") is not None else None
        })
        return _obj


