# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.obnos_vr import ObnosVr
from openapi_client.models.zastavni_pravo_vr import ZastavniPravoVr
from typing import Optional, Set
from typing_extensions import Self

class PodilVr(BaseModel):
    """
    Podíl
    """ # noqa: E501
    datum_zapisu: Optional[date] = Field(default=None, description="Datum zápisu údaje", alias="datumZapisu")
    datum_vymazu: Optional[date] = Field(default=None, description="Datum výmazu údaje", alias="datumVymazu")
    text: Optional[StrictStr] = None
    vklad: Optional[ObnosVr] = None
    velikost_podilu: Optional[ObnosVr] = Field(default=None, alias="velikostPodilu")
    splaceni: Optional[ObnosVr] = None
    zastavni_pravo: Optional[List[ZastavniPravoVr]] = Field(default=None, alias="zastavniPravo")
    __properties: ClassVar[List[str]] = ["datumZapisu", "datumVymazu", "text", "vklad", "velikostPodilu", "splaceni", "zastavniPravo"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PodilVr from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of vklad
        if self.vklad:
            _dict['vklad'] = self.vklad.to_dict()
        # override the default output from pydantic by calling `to_dict()` of velikost_podilu
        if self.velikost_podilu:
            _dict['velikostPodilu'] = self.velikost_podilu.to_dict()
        # override the default output from pydantic by calling `to_dict()` of splaceni
        if self.splaceni:
            _dict['splaceni'] = self.splaceni.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in zastavni_pravo (list)
        _items = []
        if self.zastavni_pravo:
            for _item in self.zastavni_pravo:
                if _item:
                    _items.append(_item.to_dict())
            _dict['zastavniPravo'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PodilVr from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "datumZapisu": obj.get("datumZapisu"),
            "datumVymazu": obj.get("datumVymazu"),
            "text": obj.get("text"),
            "vklad": ObnosVr.from_dict(obj["vklad"]) if obj.get("vklad") is not None else None,
            "velikostPodilu": ObnosVr.from_dict(obj["velikostPodilu"]) if obj.get("velikostPodilu") is not None else None,
            "splaceni": ObnosVr.from_dict(obj["splaceni"]) if obj.get("splaceni") is not None else None,
            "zastavniPravo": [ZastavniPravoVr.from_dict(_item) for _item in obj["zastavniPravo"]] if obj.get("zastavniPravo") is not None else None
        })
        return _obj


