# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, Field, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.adresa import Adresa
from openapi_client.models.zivnost_provozovna_pozastaveni import ZivnostProvozovnaPozastaveni
from typing import Optional, Set
from typing_extensions import Self

class ProvozovnaZaklad(BaseModel):
    """
    ProvozovnaZaklad
    """ # noqa: E501
    sidlo_provozovny: Optional[Adresa] = Field(default=None, alias="sidloProvozovny")
    umisteni_provozovny: Optional[Annotated[str, Field(strict=True, max_length=254)]] = Field(default=None, description="Umístění provozovny", alias="umisteniProvozovny")
    platnost_od: Optional[date] = Field(default=None, description="Platnost provozovny od data", alias="platnostOd")
    platnost_do: Optional[date] = Field(default=None, description="Platnost provozovny do data ", alias="platnostDo")
    pozastaveni_provozovny: Optional[List[ZivnostProvozovnaPozastaveni]] = Field(default=None, alias="pozastaveniProvozovny")
    typ_provozovny: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=1)]] = Field(default=None, description="Typ provozovny - kód (ciselnikKod: TypProvozovny) ", alias="typProvozovny")
    nazev: Optional[Annotated[str, Field(strict=True, max_length=254)]] = Field(default=None, description="Název provozovny")
    __properties: ClassVar[List[str]] = ["sidloProvozovny", "umisteniProvozovny", "platnostOd", "platnostDo", "pozastaveniProvozovny", "typProvozovny", "nazev"]

    @field_validator('typ_provozovny')
    def typ_provozovny_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{1}$", value):
            raise ValueError(r"must validate the regular expression /^\d{1}$/")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProvozovnaZaklad from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of sidlo_provozovny
        if self.sidlo_provozovny:
            _dict['sidloProvozovny'] = self.sidlo_provozovny.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in pozastaveni_provozovny (list)
        _items = []
        if self.pozastaveni_provozovny:
            for _item in self.pozastaveni_provozovny:
                if _item:
                    _items.append(_item.to_dict())
            _dict['pozastaveniProvozovny'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProvozovnaZaklad from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sidloProvozovny": Adresa.from_dict(obj["sidloProvozovny"]) if obj.get("sidloProvozovny") is not None else None,
            "umisteniProvozovny": obj.get("umisteniProvozovny"),
            "platnostOd": obj.get("platnostOd"),
            "platnostDo": obj.get("platnostDo"),
            "pozastaveniProvozovny": [ZivnostProvozovnaPozastaveni.from_dict(_item) for _item in obj["pozastaveniProvozovny"]] if obj.get("pozastaveniProvozovny") is not None else None,
            "typProvozovny": obj.get("typProvozovny"),
            "nazev": obj.get("nazev")
        })
        return _obj


