# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.adresa import Adresa
from openapi_client.models.kontakty_rs import KontaktyRs
from typing import Optional, Set
from typing_extensions import Self

class SkolaZarizeni(BaseModel):
    """
    SkolaZarizeni
    """ # noqa: E501
    kontakty: Optional[KontaktyRs] = None
    izo: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=9)]] = Field(default=None, description="IZO - resortní identifikátor")
    obchodni_jmeno: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=2000)]] = Field(default=None, description="Jméno subjektu", alias="obchodniJmeno")
    obchodni_jmeno_zkracene: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=40)]] = Field(default=None, description="Zkrácené jméno subjektu", alias="obchodniJmenoZkracene")
    typ_skoly: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=64)]] = Field(default=None, description="Typ školy", alias="typSkoly")
    adresa: Optional[Adresa] = None
    datum_vzniku: Optional[date] = Field(default=None, description="Datum vzniku", alias="datumVzniku")
    datum_zaniku: Optional[date] = Field(default=None, description="Datum zániku", alias="datumZaniku")
    __properties: ClassVar[List[str]] = ["kontakty", "izo", "obchodniJmeno", "obchodniJmenoZkracene", "typSkoly", "adresa", "datumVzniku", "datumZaniku"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SkolaZarizeni from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of kontakty
        if self.kontakty:
            _dict['kontakty'] = self.kontakty.to_dict()
        # override the default output from pydantic by calling `to_dict()` of adresa
        if self.adresa:
            _dict['adresa'] = self.adresa.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SkolaZarizeni from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "kontakty": KontaktyRs.from_dict(obj["kontakty"]) if obj.get("kontakty") is not None else None,
            "izo": obj.get("izo"),
            "obchodniJmeno": obj.get("obchodniJmeno"),
            "obchodniJmenoZkracene": obj.get("obchodniJmenoZkracene"),
            "typSkoly": obj.get("typSkoly"),
            "adresa": Adresa.from_dict(obj["adresa"]) if obj.get("adresa") is not None else None,
            "datumVzniku": obj.get("datumVzniku"),
            "datumZaniku": obj.get("datumZaniku")
        })
        return _obj


