# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class StandardizovanaAdresaFiltr(BaseModel):
    """
    Komplexní filtr pro standardizaci adresy RÚIAN 
    """ # noqa: E501
    start: Optional[Annotated[int, Field(strict=True, ge=0)]] = Field(default=None, description="Offset pro stránkování (poloha prvního vráceného prvku).")
    pocet: Optional[Annotated[int, Field(strict=True, ge=0)]] = Field(default=None, description="Počet prvků k výstupu.")
    razeni: Optional[List[StrictStr]] = None
    kod_obce: Optional[Annotated[int, Field(le=999999, strict=True, ge=0)]] = Field(default=None, description="Kód obce", alias="kodObce")
    nazev_obce: Optional[Annotated[str, Field(strict=True, max_length=48)]] = Field(default=None, description="Název obce", alias="nazevObce")
    kod_casti_obce: Optional[Annotated[int, Field(le=999999, strict=True, ge=0)]] = Field(default=None, description="Kód části obce", alias="kodCastiObce")
    nazev_casti_obce: Optional[Annotated[str, Field(strict=True, max_length=48)]] = Field(default=None, description="Název části obce", alias="nazevCastiObce")
    kod_mestskeho_casti_obvodu: Optional[Annotated[int, Field(le=999999, strict=True, ge=0)]] = Field(default=None, description="Kód městské části statutárního města nebo Prahy ", alias="kodMestskehoCastiObvodu")
    nazev_mestskeho_casti_obvodu: Optional[Annotated[str, Field(strict=True, max_length=32)]] = Field(default=None, description="Název městské části statutárního města nebo Prahy", alias="nazevMestskehoCastiObvodu")
    kod_ulice: Optional[Annotated[int, Field(le=9999999, strict=True, ge=0)]] = Field(default=None, description="Kód ulice, veřejného prostranství ", alias="kodUlice")
    nazev_ulice: Optional[Annotated[str, Field(strict=True, max_length=48)]] = Field(default=None, description="Název ulice, veřejného prostranství ", alias="nazevUlice")
    cislo_domovni: Optional[Annotated[int, Field(le=9999, strict=True)]] = Field(default=None, description="Číslo domovní", alias="cisloDomovni")
    cislo_orientacni: Optional[Annotated[int, Field(le=999, strict=True)]] = Field(default=None, description="Číslo orientační - číselná část", alias="cisloOrientacni")
    cislo_orientacni_pismeno: Optional[Annotated[str, Field(strict=True, max_length=1)]] = Field(default=None, description="Číslo orientační - písmenná část", alias="cisloOrientacniPismeno")
    kod_adresniho_mista: Optional[Annotated[int, Field(le=999999999, strict=True, ge=0)]] = Field(default=None, description="Kód adresního místa", alias="kodAdresnihoMista")
    textova_adresa: Optional[Annotated[str, Field(strict=True, max_length=1500)]] = Field(default=None, description="Nestrukturovaná adresa", alias="textovaAdresa")
    typ_standardizace_adresy: Optional[StrictStr] = Field(default=None, description="Typ požadované standardizace - kód (číselník kod:TypStandardizaceAdresy) UPLNA_STANDARDIZACE, VYHOVUJICI_ADRESY", alias="typStandardizaceAdresy")
    __properties: ClassVar[List[str]] = ["start", "pocet", "razeni", "kodObce", "nazevObce", "kodCastiObce", "nazevCastiObce", "kodMestskehoCastiObvodu", "nazevMestskehoCastiObvodu", "kodUlice", "nazevUlice", "cisloDomovni", "cisloOrientacni", "cisloOrientacniPismeno", "kodAdresnihoMista", "textovaAdresa", "typStandardizaceAdresy"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of StandardizovanaAdresaFiltr from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of StandardizovanaAdresaFiltr from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "start": obj.get("start"),
            "pocet": obj.get("pocet"),
            "razeni": obj.get("razeni"),
            "kodObce": obj.get("kodObce"),
            "nazevObce": obj.get("nazevObce"),
            "kodCastiObce": obj.get("kodCastiObce"),
            "nazevCastiObce": obj.get("nazevCastiObce"),
            "kodMestskehoCastiObvodu": obj.get("kodMestskehoCastiObvodu"),
            "nazevMestskehoCastiObvodu": obj.get("nazevMestskehoCastiObvodu"),
            "kodUlice": obj.get("kodUlice"),
            "nazevUlice": obj.get("nazevUlice"),
            "cisloDomovni": obj.get("cisloDomovni"),
            "cisloOrientacni": obj.get("cisloOrientacni"),
            "cisloOrientacniPismeno": obj.get("cisloOrientacniPismeno"),
            "kodAdresnihoMista": obj.get("kodAdresnihoMista"),
            "textovaAdresa": obj.get("textovaAdresa"),
            "typStandardizaceAdresy": obj.get("typStandardizaceAdresy")
        })
        return _obj


