# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.standardizovana_adresa import StandardizovanaAdresa
from openapi_client.models.standardizovana_adresa_filtr import StandardizovanaAdresaFiltr
from typing import Optional, Set
from typing_extensions import Self

class StandardizovaneAdresySeznam(BaseModel):
    """
    Seznam nalezených standardizovaných adres
    """ # noqa: E501
    pocet_celkem: Optional[Annotated[int, Field(strict=True, ge=0)]] = Field(default=None, description="Počet prvků seznamu.", alias="pocetCelkem")
    standardizovane_adresy: Optional[List[StandardizovanaAdresa]] = Field(default=None, alias="standardizovaneAdresy")
    stav_standardizace: Optional[StrictStr] = Field(default=None, description="Stav standardizace adresy - kod (Číselník kod:StavStandardizaceAdresy) UPLNA, CASTECNA_OBEC/..., NEUSPESNA", alias="stavStandardizace")
    request: Optional[StandardizovanaAdresaFiltr] = None
    __properties: ClassVar[List[str]] = ["pocetCelkem", "standardizovaneAdresy", "stavStandardizace", "request"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of StandardizovaneAdresySeznam from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in standardizovane_adresy (list)
        _items = []
        if self.standardizovane_adresy:
            for _item in self.standardizovane_adresy:
                if _item:
                    _items.append(_item.to_dict())
            _dict['standardizovaneAdresy'] = _items
        # override the default output from pydantic by calling `to_dict()` of request
        if self.request:
            _dict['request'] = self.request.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of StandardizovaneAdresySeznam from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "pocetCelkem": obj.get("pocetCelkem"),
            "standardizovaneAdresy": [StandardizovanaAdresa.from_dict(_item) for _item in obj["standardizovaneAdresy"]] if obj.get("standardizovaneAdresy") is not None else None,
            "stavStandardizace": obj.get("stavStandardizace"),
            "request": StandardizovanaAdresaFiltr.from_dict(obj["request"]) if obj.get("request") is not None else None
        })
        return _obj


