# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictInt, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.angazovana_osoba_rcns import AngazovanaOsobaRcns
from typing import Optional, Set
from typing_extensions import Self

class SubjektPravnickaOsoba(BaseModel):
    """
    SubjektPravnickaOsoba
    """ # noqa: E501
    ico_zrizovatel: Optional[Annotated[str, Field(min_length=8, strict=True, max_length=8)]] = Field(default=None, description="IČO zřizovatele právnické osoby. ", alias="icoZrizovatel")
    ico_nastupce: Optional[Annotated[str, Field(min_length=8, strict=True, max_length=8)]] = Field(default=None, description="IČO nástupce zrušené právnické osoby. ", alias="icoNastupce")
    zpusob_zruseni_registrace: Optional[StrictInt] = Field(default=None, description="Způsob zruseni registrace - kód", alias="zpusobZruseniRegistrace")
    organy: Optional[List[AngazovanaOsobaRcns]] = None
    __properties: ClassVar[List[str]] = ["icoZrizovatel", "icoNastupce", "zpusobZruseniRegistrace", "organy"]

    @field_validator('ico_zrizovatel')
    def ico_zrizovatel_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{8}$", value):
            raise ValueError(r"must validate the regular expression /^\d{8}$/")
        return value

    @field_validator('ico_nastupce')
    def ico_nastupce_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{8}$", value):
            raise ValueError(r"must validate the regular expression /^\d{8}$/")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SubjektPravnickaOsoba from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in organy (list)
        _items = []
        if self.organy:
            for _item in self.organy:
                if _item:
                    _items.append(_item.to_dict())
            _dict['organy'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SubjektPravnickaOsoba from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "icoZrizovatel": obj.get("icoZrizovatel"),
            "icoNastupce": obj.get("icoNastupce"),
            "zpusobZruseniRegistrace": obj.get("zpusobZruseniRegistrace"),
            "organy": [AngazovanaOsobaRcns.from_dict(_item) for _item in obj["organy"]] if obj.get("organy") is not None else None
        })
        return _obj


