# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.clen_svazu import ClenSvazu
from typing import Optional, Set
from typing_extensions import Self

class SubjektSvazCirkviZaklad(BaseModel):
    """
    SubjektSvazCirkviZaklad
    """ # noqa: E501
    clenove_svazu: Optional[List[ClenSvazu]] = Field(default=None, alias="clenoveSvazu")
    ico_nastupce: Optional[Annotated[str, Field(min_length=8, strict=True, max_length=8)]] = Field(default=None, description="IČO nástupce zrušené právnické osoby. ", alias="icoNastupce")
    __properties: ClassVar[List[str]] = ["clenoveSvazu", "icoNastupce"]

    @field_validator('ico_nastupce')
    def ico_nastupce_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{8}$", value):
            raise ValueError(r"must validate the regular expression /^\d{8}$/")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SubjektSvazCirkviZaklad from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in clenove_svazu (list)
        _items = []
        if self.clenove_svazu:
            for _item in self.clenove_svazu:
                if _item:
                    _items.append(_item.to_dict())
            _dict['clenoveSvazu'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SubjektSvazCirkviZaklad from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "clenoveSvazu": [ClenSvazu.from_dict(_item) for _item in obj["clenoveSvazu"]] if obj.get("clenoveSvazu") is not None else None,
            "icoNastupce": obj.get("icoNastupce")
        })
        return _obj


