# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.angazovana_osoba_ceu import AngazovanaOsobaCeu
from typing import Optional, Set
from typing_extensions import Self

class UpadekCeuVerejny(BaseModel):
    """
    Tabulka úpadků
    """ # noqa: E501
    podnet: Optional[StrictStr] = Field(default=None, description="Podnět ")
    spis_zn: Optional[StrictStr] = Field(default=None, description="Spisová značka", alias="spisZn")
    datum: Optional[date] = Field(default=None, description="Datum")
    detail: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=255)]] = Field(default=None, description="Odkaz na detail úpadku ")
    usneseni: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=255)]] = Field(default=None, description="Odkaz na usnesení")
    akce_upadek: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=64)]] = Field(default=None, description="Akce úpadku", alias="akceUpadek")
    typ_upadek: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=64)]] = Field(default=None, description="Typ úpadku", alias="typUpadek")
    soud_upadek: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=64)]] = Field(default=None, description="Soud rozhodující o úpadku", alias="soudUpadek")
    spravce_upadku: Optional[AngazovanaOsobaCeu] = Field(default=None, alias="spravceUpadku")
    __properties: ClassVar[List[str]] = ["podnet", "spisZn", "datum", "detail", "usneseni", "akceUpadek", "typUpadek", "soudUpadek", "spravceUpadku"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpadekCeuVerejny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of spravce_upadku
        if self.spravce_upadku:
            _dict['spravceUpadku'] = self.spravce_upadku.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpadekCeuVerejny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "podnet": obj.get("podnet"),
            "spisZn": obj.get("spisZn"),
            "datum": obj.get("datum"),
            "detail": obj.get("detail"),
            "usneseni": obj.get("usneseni"),
            "akceUpadek": obj.get("akceUpadek"),
            "typUpadek": obj.get("typUpadek"),
            "soudUpadek": obj.get("soudUpadek"),
            "spravceUpadku": AngazovanaOsobaCeu.from_dict(obj["spravceUpadku"]) if obj.get("spravceUpadku") is not None else None
        })
        return _obj


