# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.adresa import Adresa
from openapi_client.models.angazovana_osoba_nrpzs import AngazovanaOsobaNrpzs
from openapi_client.models.kontakty import Kontakty
from typing import Optional, Set
from typing_extensions import Self

class ZaznamNrpzs(BaseModel):
    """
    ZaznamNrpzs
    """ # noqa: E501
    ico: Optional[Annotated[str, Field(min_length=8, strict=True, max_length=8)]] = Field(default=None, description="Identifikační číslo osoby - IČO")
    obchodni_jmeno: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=2000)]] = Field(default=None, description="Obchodní jméno ekonomického subjektu", alias="obchodniJmeno")
    sidlo: Optional[Adresa] = None
    pravni_forma: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(default=None, description="Právní forma - kód (ciselnikKod: PravniForma, zdroj: res, com) ", alias="pravniForma")
    financni_urad: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(default=None, description="Správně příslušný finanční úřad - kód (ciselnikKod: FinancniUrad, zdroj:ufo) ", alias="financniUrad")
    datum_vzniku: Optional[date] = Field(default=None, description="Datum vzniku ekonomického subjektu ", alias="datumVzniku")
    datum_zaniku: Optional[date] = Field(default=None, description="Datum zániku ekonomického subjektu", alias="datumZaniku")
    datum_aktualizace: Optional[date] = Field(default=None, description="Datum aktualizace záznamu", alias="datumAktualizace")
    dic: Optional[StrictStr] = Field(default=None, description="Daňové identifikační číslo ve formátu CZNNNNNNNNNN")
    poradove_cislo_zar: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(default=None, description="Pořadové číslo zařízení ", alias="poradoveCisloZar")
    poradove_cislo_prac: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(default=None, description="Pořadové číslo pracovistě ", alias="poradoveCisloPrac")
    typ_subjektu: Optional[Annotated[str, Field(min_length=2, strict=True, max_length=2)]] = Field(default=None, description="Typ ekonomického subjektu - forma hospodaření - kód (ciselnikKod: TypSubjektu, zdroj: nrpzs)", alias="typSubjektu")
    druh_zarizeni: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(default=None, description="Druh zdravotnického zařízení - kód (ciselnikKod: DruhZarizeni, zdroj: nrpzs)", alias="druhZarizeni")
    primarni_zaznam: Optional[StrictBool] = Field(default=None, alias="primarniZaznam")
    typ_zrizovatele: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=1)]] = Field(default=None, description="Typ zřizovatele zdravotnického zařízení - kód (ciselnikKod: Zrizovatel, zdroj: nrpzs) ", alias="typZrizovatele")
    angazovane_osoby: Optional[List[AngazovanaOsobaNrpzs]] = Field(default=None, alias="angazovaneOsoby")
    kontakty: Optional[Kontakty] = None
    __properties: ClassVar[List[str]] = ["ico", "obchodniJmeno", "sidlo", "pravniForma", "financniUrad", "datumVzniku", "datumZaniku", "datumAktualizace", "dic", "poradoveCisloZar", "poradoveCisloPrac", "typSubjektu", "druhZarizeni", "primarniZaznam", "typZrizovatele", "angazovaneOsoby", "kontakty"]

    @field_validator('ico')
    def ico_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{8}$", value):
            raise ValueError(r"must validate the regular expression /^\d{8}$/")
        return value

    @field_validator('pravni_forma')
    def pravni_forma_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{3}$", value):
            raise ValueError(r"must validate the regular expression /^\d{3}$/")
        return value

    @field_validator('financni_urad')
    def financni_urad_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{3}$", value):
            raise ValueError(r"must validate the regular expression /^\d{3}$/")
        return value

    @field_validator('poradove_cislo_zar')
    def poradove_cislo_zar_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"\'^\d{3}$\'", value):
            raise ValueError(r"must validate the regular expression /'^\d{3}$'/")
        return value

    @field_validator('poradove_cislo_prac')
    def poradove_cislo_prac_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"\'^\d{3}$\'", value):
            raise ValueError(r"must validate the regular expression /'^\d{3}$'/")
        return value

    @field_validator('druh_zarizeni')
    def druh_zarizeni_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"\'^\d{3}$\'", value):
            raise ValueError(r"must validate the regular expression /'^\d{3}$'/")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ZaznamNrpzs from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of sidlo
        if self.sidlo:
            _dict['sidlo'] = self.sidlo.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in angazovane_osoby (list)
        _items = []
        if self.angazovane_osoby:
            for _item in self.angazovane_osoby:
                if _item:
                    _items.append(_item.to_dict())
            _dict['angazovaneOsoby'] = _items
        # override the default output from pydantic by calling `to_dict()` of kontakty
        if self.kontakty:
            _dict['kontakty'] = self.kontakty.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ZaznamNrpzs from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ico": obj.get("ico"),
            "obchodniJmeno": obj.get("obchodniJmeno"),
            "sidlo": Adresa.from_dict(obj["sidlo"]) if obj.get("sidlo") is not None else None,
            "pravniForma": obj.get("pravniForma"),
            "financniUrad": obj.get("financniUrad"),
            "datumVzniku": obj.get("datumVzniku"),
            "datumZaniku": obj.get("datumZaniku"),
            "datumAktualizace": obj.get("datumAktualizace"),
            "dic": obj.get("dic"),
            "poradoveCisloZar": obj.get("poradoveCisloZar"),
            "poradoveCisloPrac": obj.get("poradoveCisloPrac"),
            "typSubjektu": obj.get("typSubjektu"),
            "druhZarizeni": obj.get("druhZarizeni"),
            "primarniZaznam": obj.get("primarniZaznam"),
            "typZrizovatele": obj.get("typZrizovatele"),
            "angazovaneOsoby": [AngazovanaOsobaNrpzs.from_dict(_item) for _item in obj["angazovaneOsoby"]] if obj.get("angazovaneOsoby") is not None else None,
            "kontakty": Kontakty.from_dict(obj["kontakty"]) if obj.get("kontakty") is not None else None
        })
        return _obj


