# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.adresa import Adresa
from openapi_client.models.adresa_rcns import AdresaRcns
from openapi_client.models.angazma_rcns import AngazmaRcns
from openapi_client.models.registrace_rcns import RegistraceRcns
from openapi_client.models.statutatni_organ_rcns import StatutatniOrganRcns
from openapi_client.models.zpusob_jednani import ZpusobJednani
from typing import Optional, Set
from typing_extensions import Self

class ZaznamRcns(BaseModel):
    """
    Detailní informace o ekonomickém subjektu ze zdroje RCNS
    """ # noqa: E501
    ico: Optional[Annotated[str, Field(min_length=8, strict=True, max_length=8)]] = Field(default=None, description="Identifikační číslo osoby - IČO")
    obchodni_jmeno: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=2000)]] = Field(default=None, description="Obchodní jméno ekonomického subjektu", alias="obchodniJmeno")
    sidlo: Optional[Adresa] = None
    pravni_forma: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(default=None, description="Právní forma - kód (ciselnikKod: PravniForma, zdroj: res, com) ", alias="pravniForma")
    financni_urad: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(default=None, description="Správně příslušný finanční úřad - kód (ciselnikKod: FinancniUrad, zdroj:ufo) ", alias="financniUrad")
    datum_vzniku: Optional[date] = Field(default=None, description="Datum vzniku ekonomického subjektu ", alias="datumVzniku")
    datum_zaniku: Optional[date] = Field(default=None, description="Datum zániku ekonomického subjektu", alias="datumZaniku")
    datum_aktualizace: Optional[date] = Field(default=None, description="Datum aktualizace záznamu", alias="datumAktualizace")
    dic: Optional[StrictStr] = Field(default=None, description="Daňové identifikační číslo ve formátu CZNNNNNNNNNN")
    typ_subjektu: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=64)]] = Field(default=None, description="Typ subjektu - kód (ciselnikKod: TypSubjektuRcns) ", alias="typSubjektu")
    stat: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = None
    primarni_zaznam: Optional[StrictBool] = Field(default=None, alias="primarniZaznam")
    registrace: Optional[RegistraceRcns] = None
    zpusob_jednani: Optional[List[ZpusobJednani]] = Field(default=None, alias="zpusobJednani")
    adresy_subjektu: Optional[List[AdresaRcns]] = Field(default=None, alias="adresySubjektu")
    zdroj_id: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="Identifikátor záznamu ve zdrojovém registru.", alias="zdrojId")
    platnost_od: Optional[date] = Field(default=None, description="Platnost subjekt v registru od", alias="platnostOd")
    statutarni_organ: Optional[StatutatniOrganRcns] = Field(default=None, alias="statutarniOrgan")
    likvidatori: Optional[List[AngazmaRcns]] = None
    konkurzni_spravci: Optional[List[AngazmaRcns]] = Field(default=None, alias="konkurzniSpravci")
    opatrovnici: Optional[List[AngazmaRcns]] = None
    __properties: ClassVar[List[str]] = ["ico", "obchodniJmeno", "sidlo", "pravniForma", "financniUrad", "datumVzniku", "datumZaniku", "datumAktualizace", "dic", "typSubjektu", "stat", "primarniZaznam", "registrace", "zpusobJednani", "adresySubjektu", "zdrojId", "platnostOd", "statutarniOrgan", "likvidatori", "konkurzniSpravci", "opatrovnici"]

    @field_validator('ico')
    def ico_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{8}$", value):
            raise ValueError(r"must validate the regular expression /^\d{8}$/")
        return value

    @field_validator('pravni_forma')
    def pravni_forma_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{3}$", value):
            raise ValueError(r"must validate the regular expression /^\d{3}$/")
        return value

    @field_validator('financni_urad')
    def financni_urad_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{3}$", value):
            raise ValueError(r"must validate the regular expression /^\d{3}$/")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ZaznamRcns from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of sidlo
        if self.sidlo:
            _dict['sidlo'] = self.sidlo.to_dict()
        # override the default output from pydantic by calling `to_dict()` of registrace
        if self.registrace:
            _dict['registrace'] = self.registrace.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in zpusob_jednani (list)
        _items = []
        if self.zpusob_jednani:
            for _item in self.zpusob_jednani:
                if _item:
                    _items.append(_item.to_dict())
            _dict['zpusobJednani'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in adresy_subjektu (list)
        _items = []
        if self.adresy_subjektu:
            for _item in self.adresy_subjektu:
                if _item:
                    _items.append(_item.to_dict())
            _dict['adresySubjektu'] = _items
        # override the default output from pydantic by calling `to_dict()` of statutarni_organ
        if self.statutarni_organ:
            _dict['statutarniOrgan'] = self.statutarni_organ.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in likvidatori (list)
        _items = []
        if self.likvidatori:
            for _item in self.likvidatori:
                if _item:
                    _items.append(_item.to_dict())
            _dict['likvidatori'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in konkurzni_spravci (list)
        _items = []
        if self.konkurzni_spravci:
            for _item in self.konkurzni_spravci:
                if _item:
                    _items.append(_item.to_dict())
            _dict['konkurzniSpravci'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in opatrovnici (list)
        _items = []
        if self.opatrovnici:
            for _item in self.opatrovnici:
                if _item:
                    _items.append(_item.to_dict())
            _dict['opatrovnici'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ZaznamRcns from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ico": obj.get("ico"),
            "obchodniJmeno": obj.get("obchodniJmeno"),
            "sidlo": Adresa.from_dict(obj["sidlo"]) if obj.get("sidlo") is not None else None,
            "pravniForma": obj.get("pravniForma"),
            "financniUrad": obj.get("financniUrad"),
            "datumVzniku": obj.get("datumVzniku"),
            "datumZaniku": obj.get("datumZaniku"),
            "datumAktualizace": obj.get("datumAktualizace"),
            "dic": obj.get("dic"),
            "typSubjektu": obj.get("typSubjektu"),
            "stat": obj.get("stat"),
            "primarniZaznam": obj.get("primarniZaznam"),
            "registrace": RegistraceRcns.from_dict(obj["registrace"]) if obj.get("registrace") is not None else None,
            "zpusobJednani": [ZpusobJednani.from_dict(_item) for _item in obj["zpusobJednani"]] if obj.get("zpusobJednani") is not None else None,
            "adresySubjektu": [AdresaRcns.from_dict(_item) for _item in obj["adresySubjektu"]] if obj.get("adresySubjektu") is not None else None,
            "zdrojId": obj.get("zdrojId"),
            "platnostOd": obj.get("platnostOd"),
            "statutarniOrgan": StatutatniOrganRcns.from_dict(obj["statutarniOrgan"]) if obj.get("statutarniOrgan") is not None else None,
            "likvidatori": [AngazmaRcns.from_dict(_item) for _item in obj["likvidatori"]] if obj.get("likvidatori") is not None else None,
            "konkurzniSpravci": [AngazmaRcns.from_dict(_item) for _item in obj["konkurzniSpravci"]] if obj.get("konkurzniSpravci") is not None else None,
            "opatrovnici": [AngazmaRcns.from_dict(_item) for _item in obj["opatrovnici"]] if obj.get("opatrovnici") is not None else None
        })
        return _obj


