# coding: utf-8

"""
    ARES: REST API - veřejné

    REST rozhraní systému ARES

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.adresa import Adresa
from openapi_client.models.angazovana_osoba_rzp import AngazovanaOsobaRzp
from openapi_client.models.angazovany_subjekt_rzp import AngazovanySubjektRzp
from openapi_client.models.ekonomicky_subjekt_rzp_adresa import EkonomickySubjektRzpAdresa
from openapi_client.models.insolvencni_rizeni import InsolvencniRizeni
from openapi_client.models.provozovny_rzp_stav import ProvozovnyRzpStav
from openapi_client.models.zivnost import Zivnost
from openapi_client.models.zivnosti_rzp_stav import ZivnostiRzpStav
from typing import Optional, Set
from typing_extensions import Self

class ZaznamRzp(BaseModel):
    """
    Detailní informace o ekonomickém subjektu ze zdroje RŽP
    """ # noqa: E501
    ico: Optional[Annotated[str, Field(min_length=8, strict=True, max_length=8)]] = Field(default=None, description="Identifikační číslo osoby - IČO")
    obchodni_jmeno: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=2000)]] = Field(default=None, description="Obchodní jméno ekonomického subjektu", alias="obchodniJmeno")
    sidlo: Optional[Adresa] = None
    pravni_forma: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(default=None, description="Právní forma - kód (ciselnikKod: PravniForma, zdroj: res, com) ", alias="pravniForma")
    financni_urad: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(default=None, description="Správně příslušný finanční úřad - kód (ciselnikKod: FinancniUrad, zdroj:ufo) ", alias="financniUrad")
    datum_vzniku: Optional[date] = Field(default=None, description="Datum vzniku ekonomického subjektu ", alias="datumVzniku")
    datum_zaniku: Optional[date] = Field(default=None, description="Datum zániku ekonomického subjektu", alias="datumZaniku")
    datum_aktualizace: Optional[date] = Field(default=None, description="Datum aktualizace záznamu", alias="datumAktualizace")
    dic: Optional[StrictStr] = Field(default=None, description="Daňové identifikační číslo ve formátu CZNNNNNNNNNN")
    insolvencni_rizeni: Optional[InsolvencniRizeni] = Field(default=None, alias="insolvencniRizeni")
    datum_doruceni_vypisu: Optional[date] = Field(default=None, description="Datum doručení prvního výpisu sloužícího jako průkaz živnostenského podnikání, ", alias="datumDoruceniVypisu")
    adresy_subjektu: Optional[List[EkonomickySubjektRzpAdresa]] = Field(default=None, alias="adresySubjektu")
    typ_subjektu: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=64)]] = Field(default=None, description="Typ subjektu - kód (ciselnikKod: TypSubjektu, zdroj: rzp) ", alias="typSubjektu")
    zivnostensky_urad: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="Živnostenský úřadu - kód", alias="zivnostenskyUrad")
    organizacni_slozka: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=2000)]] = Field(default=None, description="Název organizační složky", alias="organizacniSlozka")
    zivnosti_stav: Optional[ZivnostiRzpStav] = Field(default=None, alias="zivnostiStav")
    datum_zapisu_vr: Optional[date] = Field(default=None, description="Datum zápisu do Obchodního nebo podobného rejstříku ", alias="datumZapisuVr")
    provozovny_stav: Optional[ProvozovnyRzpStav] = Field(default=None, alias="provozovnyStav")
    primarni_zaznam: Optional[StrictBool] = Field(default=None, description="Identifikace primárního záznamu  pozn.: U multiplicitních registrací je pouze jedna registrace primární", alias="primarniZaznam")
    kod_statu: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(default=None, description="Kód státu  (ciselnikKod: Stat, zdroj:com) ", alias="kodStatu")
    souvisejici_subjekty: Optional[List[AngazovanySubjektRzp]] = Field(default=None, alias="souvisejiciSubjekty")
    osoba_podnikatel: Optional[AngazovanaOsobaRzp] = Field(default=None, alias="osobaPodnikatel")
    angazovane_osoby: Optional[List[AngazovanaOsobaRzp]] = Field(default=None, alias="angazovaneOsoby")
    zivnosti: Optional[List[Zivnost]] = None
    __properties: ClassVar[List[str]] = ["ico", "obchodniJmeno", "sidlo", "pravniForma", "financniUrad", "datumVzniku", "datumZaniku", "datumAktualizace", "dic", "insolvencniRizeni", "datumDoruceniVypisu", "adresySubjektu", "typSubjektu", "zivnostenskyUrad", "organizacniSlozka", "zivnostiStav", "datumZapisuVr", "provozovnyStav", "primarniZaznam", "kodStatu", "souvisejiciSubjekty", "osobaPodnikatel", "angazovaneOsoby", "zivnosti"]

    @field_validator('ico')
    def ico_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{8}$", value):
            raise ValueError(r"must validate the regular expression /^\d{8}$/")
        return value

    @field_validator('pravni_forma')
    def pravni_forma_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{3}$", value):
            raise ValueError(r"must validate the regular expression /^\d{3}$/")
        return value

    @field_validator('financni_urad')
    def financni_urad_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{3}$", value):
            raise ValueError(r"must validate the regular expression /^\d{3}$/")
        return value

    @field_validator('zivnostensky_urad')
    def zivnostensky_urad_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d{6}$", value):
            raise ValueError(r"must validate the regular expression /^\d{6}$/")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ZaznamRzp from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of sidlo
        if self.sidlo:
            _dict['sidlo'] = self.sidlo.to_dict()
        # override the default output from pydantic by calling `to_dict()` of insolvencni_rizeni
        if self.insolvencni_rizeni:
            _dict['insolvencniRizeni'] = self.insolvencni_rizeni.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in adresy_subjektu (list)
        _items = []
        if self.adresy_subjektu:
            for _item in self.adresy_subjektu:
                if _item:
                    _items.append(_item.to_dict())
            _dict['adresySubjektu'] = _items
        # override the default output from pydantic by calling `to_dict()` of zivnosti_stav
        if self.zivnosti_stav:
            _dict['zivnostiStav'] = self.zivnosti_stav.to_dict()
        # override the default output from pydantic by calling `to_dict()` of provozovny_stav
        if self.provozovny_stav:
            _dict['provozovnyStav'] = self.provozovny_stav.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in souvisejici_subjekty (list)
        _items = []
        if self.souvisejici_subjekty:
            for _item in self.souvisejici_subjekty:
                if _item:
                    _items.append(_item.to_dict())
            _dict['souvisejiciSubjekty'] = _items
        # override the default output from pydantic by calling `to_dict()` of osoba_podnikatel
        if self.osoba_podnikatel:
            _dict['osobaPodnikatel'] = self.osoba_podnikatel.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in angazovane_osoby (list)
        _items = []
        if self.angazovane_osoby:
            for _item in self.angazovane_osoby:
                if _item:
                    _items.append(_item.to_dict())
            _dict['angazovaneOsoby'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in zivnosti (list)
        _items = []
        if self.zivnosti:
            for _item in self.zivnosti:
                if _item:
                    _items.append(_item.to_dict())
            _dict['zivnosti'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ZaznamRzp from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ico": obj.get("ico"),
            "obchodniJmeno": obj.get("obchodniJmeno"),
            "sidlo": Adresa.from_dict(obj["sidlo"]) if obj.get("sidlo") is not None else None,
            "pravniForma": obj.get("pravniForma"),
            "financniUrad": obj.get("financniUrad"),
            "datumVzniku": obj.get("datumVzniku"),
            "datumZaniku": obj.get("datumZaniku"),
            "datumAktualizace": obj.get("datumAktualizace"),
            "dic": obj.get("dic"),
            "insolvencniRizeni": InsolvencniRizeni.from_dict(obj["insolvencniRizeni"]) if obj.get("insolvencniRizeni") is not None else None,
            "datumDoruceniVypisu": obj.get("datumDoruceniVypisu"),
            "adresySubjektu": [EkonomickySubjektRzpAdresa.from_dict(_item) for _item in obj["adresySubjektu"]] if obj.get("adresySubjektu") is not None else None,
            "typSubjektu": obj.get("typSubjektu"),
            "zivnostenskyUrad": obj.get("zivnostenskyUrad"),
            "organizacniSlozka": obj.get("organizacniSlozka"),
            "zivnostiStav": ZivnostiRzpStav.from_dict(obj["zivnostiStav"]) if obj.get("zivnostiStav") is not None else None,
            "datumZapisuVr": obj.get("datumZapisuVr"),
            "provozovnyStav": ProvozovnyRzpStav.from_dict(obj["provozovnyStav"]) if obj.get("provozovnyStav") is not None else None,
            "primarniZaznam": obj.get("primarniZaznam"),
            "kodStatu": obj.get("kodStatu"),
            "souvisejiciSubjekty": [AngazovanySubjektRzp.from_dict(_item) for _item in obj["souvisejiciSubjekty"]] if obj.get("souvisejiciSubjekty") is not None else None,
            "osobaPodnikatel": AngazovanaOsobaRzp.from_dict(obj["osobaPodnikatel"]) if obj.get("osobaPodnikatel") is not None else None,
            "angazovaneOsoby": [AngazovanaOsobaRzp.from_dict(_item) for _item in obj["angazovaneOsoby"]] if obj.get("angazovaneOsoby") is not None else None,
            "zivnosti": [Zivnost.from_dict(_item) for _item in obj["zivnosti"]] if obj.get("zivnosti") is not None else None
        })
        return _obj


